//simple calculator for permutations and combinations

#include <stdio.h>
#include <stdlib.h>
#include "perms_functions.h"

int main()
{
	unsigned long int numberOfItems = 0, permutations = 0, combinations = 0;
	unsigned int amountAtATime = 0; //number of items taken at a time
	char x; //our option
	
	fprintf( stdout, "Command Line Permutations and Combinations Calculator\n\n" );
	fprintf( stdout, "Usage:\n\t'a' to calculate permutations with repeated numbers\n" );
	fprintf( stdout, "\t'b' to calculate permutations with no repeated numbers\n" );
	fprintf( stdout, "\t'c' to calculate combinations with repeated numbers\n" );
	fprintf( stdout, "\t'd' to calculate combinations with no repeated numbers\n\n" );
	
	fprintf( stdout, "Enter the desired option (enter a number to terminate): " );
	
	if ( fscanf( stdin, "%c", &x ) == 1 )
	{
		switch ( x ) 
		{
			case 'a':
				fprintf( stdout, "Enter 'n' and 'r': " );
				if ( fscanf( stdin, "%lu%u", &numberOfItems, &amountAtATime ) == 2  )
					calcPermsOne( numberOfItems, amountAtATime, &permutations );
				break;
				
			case 'b':
				fprintf( stdout, "Enter 'n' and 'r': " );
				if ( fscanf( stdin, "%lu%u", &numberOfItems, &amountAtATime ) == 2  )
					calcPermsTwo( numberOfItems, amountAtATime, &permutations );
				break;
				
			case 'c':
				fprintf( stdout, "Enter 'n' and 'r': " );
				if ( fscanf( stdin, "%lu%u", &numberOfItems, &amountAtATime ) == 2  )
					calcCombOne( numberOfItems, amountAtATime, &combinations );
				break;
				
			case 'd':
				fprintf( stdout, "Enter 'n' and 'r': " );
				if ( fscanf( stdin, "%lu%u", &numberOfItems, &amountAtATime ) == 2  )
					calcCombTwo( numberOfItems, amountAtATime, &combinations );
				break;
				
			default: //handle bad options
				fprintf( stdout, "Bad option: use a, b, c, or d" );
		}
	}
	
	displayResults( stdout, &permutations, &combinations );
	
	return 0;
}
