//our function definitions

#include <math.h>
#include "perms_functions.h"

//our (recursive) function for calculating factorials
unsigned long int factorial( unsigned long int number ) 
{
	if ( number <= 1 ) 
		return 1;
	else if ( number > 1 )
		return number * factorial( number - 1 );
}

//case 1: permutation; numbers may be repeated [ n^r ]
void calcPermsOne( unsigned long int n, unsigned long int r,
				  unsigned long int * permutations )
{
	*permutations = pow( n, r );
}

//case 2: permutation; numbers may not be repeated [ n!/(n-r)! ]
void calcPermsTwo( unsigned long int n, unsigned long int r,
				  unsigned long int * permutations )
{
	//calculate n!
	unsigned long int nFactorial = factorial( n );
	
	//calculate (n-r)!
	unsigned long int nrFactorial = factorial ( (n - r) );
	
	//calculate permutations
	*permutations = nFactorial / nrFactorial;
}

//case 3: combination; numbers may be repeated [ (n+r-1)!/r!(n-1)! ]
void calcCombOne( unsigned long int n, unsigned long int r,
				 unsigned long int * combinations )
{
	//calculate (n+r-1)!
	unsigned long int nrOneFactorial = factorial( n + r - 1 );
	
	//calculate r!
	unsigned long int rFactorial = factorial( r );
	
	//calculate (n-1)!
	unsigned long int nOneFactorial = factorial ( n - 1 );
	
	*combinations = nrOneFactorial / ( rFactorial * nOneFactorial );
}

//case 4: combination; numbers may not be repeated [ n!/r!(n-r)! ]
void calcCombTwo( unsigned long int n, unsigned long int r,
				 unsigned long int * combinations )
{
	//calculate n!
	unsigned long int nFactorial = factorial( n );
	
	//calculate r!
	unsigned long int rFactorial = factorial( r );
	
	//calculate (n-r)!
	if ( n - r > 0 )
	{
		/* appears the n is taking on an enormous value at this function call,
		   which crashes the program. */

		unsigned long int nrFactorial = factorial ( n - r ); 	
		*combinations = nFactorial / ( rFactorial * nrFactorial );
	}
	
	else 
	{
		fprintf( stdout, "Cannot take the factorial of a negative" );
	}
}

void displayResults ( FILE * os, unsigned long int * permutations,
					 unsigned long int * combinations )
{
	if ( *permutations != 0 )
		fprintf( stdout, "The number of permutations is %lu\n", *permutations );
	
	else if ( *combinations != 0 )
		fprintf( stdout, "The number of combinations is %lu\n", *combinations );
}